<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { computed, onMounted, reactive, watch } from "vue";
import { useWorkflowExecutionStore } from "@/stores/workflowExecutions";
import type { RouteLocationRaw } from "vue-router";
import { Modal } from "bootstrap";
import { useRouter } from "vue-router";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import type {
  WorkflowExecutionOut,
  WorkflowVersionOut,
} from "@/client/types.gen";
import { useNameStore } from "@/stores/names";
import { useWorkflowStore } from "@/stores/workflows";
import { createDownloadUrl } from "@/utils/DownloadJson";
import type {
  NestedWorkflowParameters,
  TemporaryParams,
} from "@/types/WorkflowParameters";
import ParameterTable from "@/components/workflows/ParameterTable.vue";

const nameRepository = useNameStore();
const executionRepository = useWorkflowExecutionStore();
const workflowRepository = useWorkflowStore();
const router = useRouter();

let parameterModal: Modal | null = null;

const props = defineProps<{
  modalId: string;
  executionId?: string;
}>();

const parameterState = reactive<{
  loading: boolean;
  error: boolean;
}>({
  loading: false,
  error: false,
});

const execution = computed<WorkflowExecutionOut | undefined>(() => {
  if (props.executionId == undefined) {
    return undefined;
  }
  return executionRepository.executionMapping[props.executionId] ?? undefined;
});

const workflowVersion = computed<WorkflowVersionOut | undefined>(
  () =>
    workflowRepository.versionMapping[
      execution.value?.workflow_version_id ?? ""
    ],
);

watch(execution, (newVal, oldVal) => {
  if (
    newVal != undefined &&
    newVal.execution_id != oldVal?.execution_id &&
    newVal.workflow_id != undefined &&
    workflowRepository.workflowMapping[newVal.workflow_id] == undefined
  ) {
    workflowRepository.fetchWorkflow(newVal.workflow_id);
  }
});

const logs_s3_path = computed<string | undefined>(
  () => execution.value?.logs_s3_path ?? undefined,
);
const debug_s3_path = computed<string | undefined>(
  () => execution.value?.debug_s3_path ?? undefined,
);
const provenance_s3_path = computed<string | undefined>(
  () => execution.value?.provenance_s3_path ?? undefined,
);
const notes = computed<string | undefined>(
  () => execution.value?.notes ?? undefined,
);

const parameters = computed<NestedWorkflowParameters | undefined>(() => {
  if (props.executionId == undefined) {
    return undefined;
  }
  return executionRepository.parameters[props.executionId] ?? undefined;
});

const parameterTableParams = computed<TemporaryParams>(() => {
  return {
    params: parameters.value,
    metaParams: {
      notes: notes.value,
      provenance_s3_path: provenance_s3_path.value,
      debug_s3_path: debug_s3_path.value,
      logs_s3_path: logs_s3_path.value,
    },
  };
});

const parameterDownloadUrl = computed<string | undefined>(() => {
  if (parameters.value == undefined) {
    return undefined;
  }
  return createDownloadUrl(
    JSON.stringify(parameters.value, null, 2),
    "application/json",
  );
});

const workflowName = computed<string>(() => {
  if (props.executionId) {
    const execution = executionRepository.executionMapping[props.executionId];
    if (
      execution?.workflow_id != undefined &&
      execution?.workflow_version_id != undefined
    ) {
      return (
        nameRepository.getName(execution.workflow_id) +
        "@" +
        nameRepository.getName(execution.workflow_version_id)
      );
    }
  }
  return "";
});

function fetchWorkflowExecutionParameters(executionId?: string) {
  parameterState.error = false;
  if (executionId != undefined) {
    parameterState.loading = true;
    executionRepository
      .fetchExecutionParameters(executionId)
      .catch(() => {
        parameterState.error = true;
      })
      .finally(() => {
        parameterState.loading = false;
      });
  }
}

function handleLinkClick(route: RouteLocationRaw) {
  parameterModal?.hide();
  router.push(route);
}

function saveParameters() {
  if (parameters.value != undefined) {
    executionRepository.pushTemporaryParameters(parameters.value, {
      logs_s3_path: logs_s3_path?.value?.split("/")?.slice(0, -1)?.join("/"),
      debug_s3_path: debug_s3_path?.value?.split("/")?.slice(0, -1)?.join("/"),
      provenance_s3_path: provenance_s3_path?.value
        ?.split("/")
        ?.slice(0, -1)
        ?.join("/"),
      notes: notes.value,
    });
  }
}

watch(
  () => props.executionId,
  (newId, oldId) => {
    if (newId != oldId) {
      fetchWorkflowExecutionParameters(newId);
    }
  },
);

onMounted(() => {
  fetchWorkflowExecutionParameters(props.executionId);
  parameterModal = Modal.getOrCreateInstance("#" + props.modalId);
});
</script>

<template>
  <bootstrap-modal
    :modal-id="modalId"
    :static-backdrop="false"
    modal-label="Workflow Execution Parameters Modal"
    size-modifier-modal="xl"
  >
    <template #header
      >Workflow Execution Parameters
      <b>
        {{ workflowName }}
      </b>
    </template>
    <template #body>
      <div v-if="parameterState.error" class="text-center fs-4 mt-5">
        <font-awesome-icon
          icon="fa-solid fa-magnifying-glass"
          class="mb-3 fs-0"
          style="color: var(--bs-secondary)"
        />
        <p>
          Workflow Execution <i>{{ props.executionId }}</i> not found
        </p>
      </div>
      <parameter-table
        v-else-if="props.executionId"
        :loading="parameterState.loading"
        :parameters="parameterTableParams"
        @link-clicked="handleLinkClick"
      />
    </template>
    <template #footer>
      <router-link
        v-if="workflowVersion"
        class="btn btn-primary"
        :class="{
          disabled: parameterState.loading || parameterState.error,
        }"
        :to="{
          name: 'workflow-start',
          params: {
            versionId: workflowVersion.workflow_version_id,
            workflowId: workflowVersion.workflow_id,
          },
          query: {
            workflowModeId: execution?.mode_id,
          },
        }"
        @click.prevent="
          saveParameters();
          handleLinkClick({
            name: 'workflow-start',
            params: {
              versionId: workflowVersion.workflow_version_id,
              workflowId: workflowVersion.workflow_id,
            },
            query: {
              workflowModeId: execution?.mode_id,
            },
          });
        "
      >
        Rerun Execution
        <font-awesome-icon icon="fa-solid fa-arrow-rotate-right" class="me2" />
      </router-link>
      <a
        class="btn btn-primary"
        role="button"
        :class="{
          disabled: parameterState.loading || parameterState.error,
        }"
        :href="parameterDownloadUrl"
        :download="`parameters-${executionId?.replace(/-/g, '')}.json`"
        :tabindex="parameterState.loading || parameterState.error ? -1 : 0"
        :aria-disabled="parameterState.loading || parameterState.error"
      >
        Download Parameters
        <font-awesome-icon icon="fa-solid fa-download" class="ms-1" />
      </a>
      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">
        Close
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
